using System;
using System.Collections.Specialized ;
using System.IO ;

namespace shobonjtag
{
	/// <summary>
	/// BSDL s bit ̑ΉǂރNXB܂CȂB
	/// 
	/// BSDL t@C̍\Ă邱ƂOɂ͂ĂB
	/// ԂقƂǓǂ߂ȂƎv :-)
	/// 
	/// Ƃ肠 EPF10K10L84  ep1c12f328 ǂ߂悤ɂ͂ĂijB
	/// ȂCȂƎvB
	/// </summary>
	public class TinyBsdl
	{
		/// <summary>
		/// sԍƐM̂̎
		/// </summary>
		StringDictionary pinmap ;

		/// <summary>
		/// ŏIIɐ Pin (Viewer p)
		/// </summary>
		PinItem[] pi ;

		/// <summary>
		/// RXgN^
		/// </summary>
		public TinyBsdl() {
		}

		/// <summary>
		/// ͌ʂ󂯎
		/// </summary>
		/// <returns></returns>
		public PinItem[] getPinItem() {
			return pi ;
		}

		/// <summary>
		/// pass ܂œǂݔ΂
		/// </summary>
		/// <returns></returns>
		private string pass_string(string pass,StreamReader sr) {
			string line = null ;
			while ((line = sr.ReadLine()) != null) {
				if (line.IndexOf(pass) >= 0) {
					break ;
				}
			}			
			return line ;
		}

		/// <summary>
		/// M̂ƃs̎쐬
		/// </summary>
		/// <param name="sr"></param>
		/// <returns></returns>
		private void create_PIN_MAP(StreamReader sr) {
			string line ;
			string pin ;
			string name ;
			pinmap = new StringDictionary() ;

			while ((line = sr.ReadLine()) != null) {

				line = line.Trim() ;
				if ((line.Length < 2) || (line[0] == '-')) continue ;
				
				int start = line.IndexOf("\"") ;
				if (start < 0) {
					break ;
				}
				int end = line.IndexOf("\"",start+1) ;
				if (end < 0) {
					break ;
				}

				string innerstr = line.Substring(start+1,end - start - 1) ;
				string[] param = innerstr.Split(",".ToCharArray(),10) ; // Ƃ肠PO܂ŁB
				// Ő󔒂폜
				for (int i=0;i<param.Length;i++) {
					param[i] = param[i].Trim() ;
					int colon = param[i].IndexOf(":") ;
					if (colon < 0) {
						break ;
					}

					// sɒǉ
					name = param[i].Substring(0,colon) ;
					name = name.Trim() ;
					pin = param[i].Substring(colon+1) ;
					pin = pin.Trim() ;
					//Console.WriteLine("pinmap["+name+"]="+pin) ;
					pinmap.Add(name,pin) ;
				}
			}			
		}

		/// <summary>
		/// ViewForm p PinItem ނ肭쐬
		/// </summary>
		/// <param name="sr"></param>
		private int create_PIN_ITEM(StreamReader sr,int bits) {
			string line ;
			int count = 0;

			pi = new PinItem[bits] ;
			while ((line = sr.ReadLine()) != null) {
				
				line = line.Trim() ;
				if ((line.Length < 2) || (line[0] == '-')) continue ;

				// _uNI[g̈ʒu
				int start = line.IndexOf("\"") ;
				if (start < 0) {
					return -1 ;
				}

				// ʂ̈ʒu
				int sparen = line.IndexOf("(") ;
				int eparen = line.IndexOf(")") ;
				if ((sparen < 0) || (eparen < 0)) {
					return -1 ;
				}
				
				// rbgԍ
				string bitstr = line.Substring(start+1,sparen - start - 1) ;
				int bitno ;
				try {
					bitno = int.Parse(bitstr) ;
					if ((bitno >= bits) && (bitno < 0)) {
						return -1 ;
					}
				} catch {
					return -1 ;
				}

				// ʓevfo
				string parenstr = line.Substring(sparen+1,eparen-sparen-1) ;
				string[] param = parenstr.Split(",".ToCharArray(),4) ; // Ƃ肠SB

				// Ő󔒂폜
				for (int i=0;i<param.Length;i++) {
					param[i] = param[i].Trim() ;
				}

				//    bitno    0     1        2      3
				//    "   7 (BC_1, PB07_15, output3, X, 6, 0, Z)," &
				//	  "   8 (BC_1, PB07_15, input, X)," &
				string pinno = pinmap[param[1]] ;
				pi[bitno] = new PinItem() ;
				pi[bitno].bitno   = bitno.ToString() ;
				pi[bitno].pinno   = pinno ;
				pi[bitno].usertag = param[1] ;
				pi[bitno].bittype = param[2] ;
				//Console.WriteLine("bit "+bitno+" pin#"+pi[bitno].pinno+" ("+pi[bitno].usertag+") ["+pi[bitno].bittype+"]") ;
				if (++count >= bits) {
					return 0 ;
				}
			}			
			return -1 ;
		}


		/// <summary>
		/// BSDL t@Cǂ
		/// </summary>
		/// <param name="filename"></param>
		public int readFile(string filename) {
			try {
				using (StreamReader sr = new StreamReader(filename)) {
					// PIN_MAP_STRING ߂܂œǂݔ΂
					if (pass_string("PIN_MAP_STRING",sr) != null) {
						create_PIN_MAP(sr) ;
						if (pinmap.Count == 0) {
							// Ȃ
							return -1 ;
						}

						// BOUNDARY_LENGTH ߂܂œǂݔ΂
						string bitstr = pass_string("BOUNDARY_LENGTH",sr) ;
						if (bitstr == null) {
							// ł
							return -1 ;
						}

						// entity is xxxx
						int bitpos = bitstr.IndexOf("is") ;
						if (bitpos < 0) {
							// ł
							return -1 ;
						}

						// bit ̎o
						string lenstr = bitstr.Substring(bitpos+2,bitstr.Length-(bitpos+2)-1) ;
						int bits = int.Parse(lenstr) ;
						//Console.WriteLine("BSLENGTH ="+bits) ;

						// BOUNDARY_REGISTER ߂܂œǂݔ΂
						if (pass_string("BOUNDARY_REGISTER",sr) != null) {
							return create_PIN_ITEM(sr,bits) ;
						}
					}
					return -1 ;
				}
			} catch (Exception) {
				return -1 ;
			}
		}
	}
}
